# Connection

### Connect to TapTalk.io server

You can manually connect to TapTalk.io by calling `connect()` method.

{% hint style="warning" %}
**Note:** Please make sure that you have finished authentication by calling `authenticate()`method, otherwise, it will return an error
{% endhint %}

{% tabs %}
{% tab title="Java" %}

```java
import io.taptalk.TapTalk.Helper.TapTalk;
import io.taptalk.TapTalk.Listener.TapCommonListener;

...

TapTalk.connect(new TapCommonListener() {
    @Override
    public void onSuccess(String successMessage) {
        // Successfully connected to TapTalk.io server
    }

    @Override
    public void onError(String errorCode, String errorMessage) {

    }
});
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
import io.taptalk.TapTalk.Helper.TapTalk
import io.taptalk.TapTalk.Listener.TapCommonListener

...

TapTalk.connect(object : TapCommonListener() {
    override fun onSuccess(successMessage: String?) {
        // Successfully connected to TapTalk.io server
    }

    override fun onError(errorCode: String?, errorMessage: String?) {

    }
})
```

{% endtab %}
{% endtabs %}

### Disconnect from TapTalk.io server

You can disconnect from TapTalk.io when the user no longer needs to receive messages from an online state. But the user can still receive push notifications for new messages when the app is closed.

When the user is disconnected from the server, all event delegates will stop receiving event callbacks from the server.

{% tabs %}
{% tab title="Java" %}

```java
import io.taptalk.TapTalk.Helper.TapTalk;

...

TapTalk.disconnect();
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
import io.taptalk.TapTalk.Helper.TapTalk

...

TapTalk.disconnect()
```

{% endtab %}
{% endtabs %}

### Check Connection Status

You can check whether you are connected to TapTalk.io server by calling **`isConnected()`** method.

{% tabs %}
{% tab title="Java" %}

```java
import io.taptalk.TapTalk.Helper.TapTalk;

...

boolean isConnected = TapTalk.isConnected();
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
import io.taptalk.TapTalk.Helper.TapTalk

...

var isConnected = TapTalk.isConnected()
```

{% endtab %}
{% endtabs %}

### Enable / Disable Auto Connect

You can choose to enable or disable auto connect by calling these methods. TapTalk.io will automatically connect to the server every time the user opens the app from the background when auto connect is enabled. Please note that the **default value** is **enabled**.

{% tabs %}
{% tab title="Java" %}

```java
import io.taptalk.TapTalk.Helper.TapTalk;

...

@Override
public void onCreate() {
    ...
    
    // Call this method to enable or disable auto connect
    // The default value is set to enabled if you do not set this method
    TapTalk.setAutoConnectEnabled(IS_ENABLED);
}
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
import io.taptalk.TapTalk.Helper.TapTalk

...

override fun onCreate(savedInstanceState: Bundle?) {
    ...
    
    // Call this method to enable or disable auto connect
    // The default value is set to enabled if you do not set this method
    TapTalk.setAutoConnectEnabled(IS_ENABLED)
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}

#### Parameters

`IS_ENABLED`: (BOOL) set to true to enable auto connect to TapTalk server
{% endhint %}

### Get Auto Connect Status

Use this method to obtain auto connect status. This method will return **`true`** if auto connect is enabled

{% tabs %}
{% tab title="Java" %}

```java
import io.taptalk.TapTalk.Helper.TapTalk;

...

boolean isAutoConnectEnabled = TapTalk.isAutoConnectEnabled();
```

{% endtab %}

{% tab title="Kotlin" %}

```kotlin
import io.taptalk.TapTalk.Helper.TapTalk

...

var isAutoConnectEnabled = TapTalk.isAutoConnectEnabled()
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.taptalk.io/powertalk-chat-sdk-documentation/powertalk-android/connection.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
